
var _createElement = require('./create-element')
var helpers = require('hyperscript-helpers')
var parse = require('parse-hyperscript')
var hyphenate = require('@f/hyphenate')
var cn = require('classnames')

var toInlineStyle = function (def) { return Object.keys(def)
  .map(function (prop) { return hyphenate(prop) + ':' + def[prop]; })
  .join(';'); }

var idTransform = function (key, val) { return val; }

var defaultTransformAttrs = function (key, val) {
  switch (key) {
    case 'className':
      return defaultTransformAttrs('class', val)
    case 'class':
      return [key, cn(val)]
    case 'style':
      return [
        key,
        typeof val !== 'string'
          ? toInlineStyle(val)
          : val
      ]
    default:
      return [key, val]
  }
}

var createElementx = function (transformAttrs) {
  if ( transformAttrs === void 0 ) transformAttrs = idTransform;

  function createElement () {
    return _createElement(
      function (key, val) { return transformAttrs(key, defaultTransformAttrs(key, val)); },
      parse(arguments)
    )
  }

  return Object.assign({}, helpers(createElement), {
    h: createElement,
    createElement: createElement
  })
}

Object.assign(
  module.exports,
  createElementx(),
  { createElementx: createElementx }
)
